#include "utils.h"
#include "getopts.h"

void DumpBitFile()
	{
	const char *FileName = RequiredValueOpt("dumpbit");

	FILE *f = OpenStdioFile(FileName);
	unsigned Size = (unsigned) GetStdioFileSize(f);

	unsigned From = 0;
	unsigned To = Size;
	if (ValueOpt("from"))
		From = RequiredIntOpt("from");
	if (ValueOpt("to"))
		To = RequiredIntOpt("to");
	if (ValueOpt("length"))
		{
		unsigned Length = RequiredIntOpt("length");
		if (Length == 0)
			return;
		To = From + Length - 1;
		}

	SetStdioFilePos(f, From);
	unsigned Left = To + 1 - From;
	const unsigned BUFFSIZE = 8;
	char Buffer[BUFFSIZE];
	for (;;)
		{
		if (Left == 0)
			break;
		unsigned Bytes = Left;
		if (Bytes > BUFFSIZE)
			Bytes = BUFFSIZE;
		ReadStdioFile(f, Buffer, Bytes);
		for (unsigned i = 0; i < Bytes; ++i)
			{
			byte b = (byte) Buffer[i];
			for (int j = 0; j < 8; ++j)
				Dump("%d", (b & (1 << j)) ? 1 : 0);
			Dump(" ");
			}
		Dump("\n");
		for (unsigned i = 0; i < Bytes; ++i)
			{
			byte b = (byte) Buffer[i];
			Dump("      %02x ", b);
			}
		Dump("\n");
		unsigned *uBuffer = (unsigned *) Buffer;
		for (unsigned i = 0; i < Bytes/4; ++i)
			{
			unsigned u = uBuffer[i];
			Dump("                           %08x ", u);
			}

		Dump("\n\n");
		Left -= Bytes;
		}
	}
