#ifndef evodists_h
#define evodists_h

const unsigned RateBinCount = P_MicroThreshold*10;

struct BigLHF
	{
	gpos_t LoLength;
	gpos_t HiLength;
	double LoRate;
	double HiRate;
	double IntegratedRate;

	void LogMe() const
		{
		Log(" Len %"PF" - %"PF", Rate %.3g - %.3g",
		  LoLength, HiLength, LoRate, HiRate);
		}
	};

#define EXTERN extern
#include "rateglobals.h"

void ComputeMicroDist(const char *Msg, const vector<pair<gpos_t, double> > &Rates,
  vector<double> &MicroRates, double &IntegratedMicroRate,
  vector<unsigned> &MicroBins);
void ComputeBigDist(const char * /*Msg*/, const vector<pair<gpos_t, double> > &Rates,
  double &IntegratedBigRate, vector<BigLHF> &BigLHFs, vector<unsigned> &BigBins);
gpos_t GetRandLengthLHF(const BigLHF &LHF);

#endif // evodists_h
