#include <ctype.h>
#include <errno.h>
#include "seqfile.h"
#include "getopts.h"
#include "utils.h"

bool GetSeq(FILE *f, std::string &Seq, std::string &Label)
	{
	Seq.clear();
	Label.clear();

	Seq.reserve(1000000);
	Label.reserve(4096);

	if (feof(f))
		return false;

	int c = fgetc(f);
	if (c != '>')
		Die("GetSeq, expected '>'");

	for (;;)
		{
		int c = fgetc(f);
		if (c < 0)
			Die("Error reading file errno=%d", errno);
		if (c == '\r')
			continue;
		if (c == '\n')
			break;
		Label += (char) c;
		}

	for (;;)
		{
		int c = fgetc(f);
		if (c < 0)
			{
			if (feof(f))
				break;
			Die("Error reading file errno=%d", errno);
			}
		if (c == '>')
			{
			fseek(f, -1, SEEK_CUR);
			break;
			}
		if (isalpha(c) || c == '-')
			Seq += (char) c;

		if (Seq.size() >= Seq.capacity() - 100)
			Seq.reserve(Seq.capacity() + 1000000);
		}

	return true;
	}
