#ifndef icevo_h
#define icevo_h

#include <list>
#include <vector>
#include "types.h"
#include "mul.h"
#include "intlist.h"

using namespace std;

struct AncContig
	{
	AncContig()
		{
		ChrIndex = UINT_MAX;
		Pos = GPOS_T_MAX;
		Length = GPOS_T_MAX;
		Plus = true;
		Copy = false;
		}

	unsigned ChrIndex;
	gpos_t Pos;
	gpos_t Length;
	bool Plus;
	bool Copy;
	};

class InterChrEvolver
	{
public:
	gpos_t GetLength() const;
	void GetRandomPos(unsigned &ChrIndex, gpos_t &Pos) const;
	void GetRandomPosDifferentChr(unsigned ChrIndex, unsigned &ChrIndex2,
	  gpos_t &Pos2) const;
	gpos_t GetChrLength(unsigned ChrIndex) const;

	bool Try_InterChrCopy();
	bool Try_InterChrMove();
	bool Try_ChrFuse();
	bool Try_ChrSplit();

	void Copy(unsigned FromChrIndex, gpos_t FromPos, 
	  unsigned ToChrIndex, gpos_t ToPos, gpos_t Length);

	void Move(unsigned FromChrIndex, gpos_t FromPos, 
	  unsigned ToChrIndex, gpos_t ToPos, gpos_t Length);

	bool AcceptInsert(unsigned ChrIndex, gpos_t Pos, gpos_t Length) const;
	bool AcceptMove(unsigned ChrIndex, gpos_t Pos, gpos_t Length) const;

	void GetACs(unsigned ChrIndex, gpos_t Pos, gpos_t Length,
	  vector<AncContig> &ACs) const;
	void InsertACs(unsigned ChrIndex, gpos_t Pos, vector<AncContig> &ACs);

	void LogMe() const;
	void Validate() const;

private:
	vector<list<AncContig> > m_AncChrs;
	vector<list<AncContig> > m_Chrs;
	vector<double> m_EventRates;
	};

#endif // icevo_h
