#include "stack.h"

void MakeOverlapGraph(const AIXVec &AIXs, unsigned GenIndex, unsigned ChrId,
  IntVecVec &Edges)
	{
	std::vector<AIBP> BPs;
	GetBendpoints(AIXs, GenIndex, ChrId, BPs, 0, true);

	const unsigned AICount = (unsigned) AIXs.size();
	const unsigned BPCount = (unsigned) BPs.size();

	Edges.clear();
	Edges.resize(AICount);

	std::set<unsigned> Window;
	for (unsigned BPIndex = 0; BPIndex < BPCount; ++BPIndex)
		{
		const AIBP &BP = BPs[BPIndex];
		unsigned AIIndex = BP.AlnInfoIndex;
		asserta(AIIndex < AICount);

		if (BP.IsLo)
			{
			std::pair<std::set<unsigned>::iterator, bool> Result = Window.insert(AIIndex);
			asserta(Result.second);
			}
		else
			{
			size_t n = Window.erase(AIIndex);
			asserta(n == 1);

			for (std::set<unsigned>::const_iterator p = Window.begin();
			  p != Window.end(); ++p)
				{
				unsigned AIIndex2 = *p;
				asserta(AIIndex2 < AICount);

				Edges[AIIndex].push_back(AIIndex2);
				}
			}
		}
	asserta(Window.size() == 0);
	}
