#include "mus.h"

void ScanSeqGaps(const string &Seq, ptrOnGapFn2 OnGap, ptrOnGapFn2 OnTerminalGap)
	{
	uns GapStart = UINT_MAX;
	uns ColCount = SIZE(Seq);
	for (uns ColIndex = 0; ColIndex < ColCount; ++ColIndex)
		{
		char c = Seq[ColIndex];
		if (IsGapChar(c))
			{
			if (GapStart == UINT_MAX)
				GapStart = ColIndex;
			}
		else
			{
			if (GapStart != UINT_MAX)
				{
				uns GapLength = ColIndex - GapStart;
				if (GapStart == 0 || GapStart + GapLength == ColCount)
					OnTerminalGap(0, GapLength);
				else
					OnGap(GapStart, GapLength);
				GapStart = UINT_MAX;
				}
			}
		}
	if (GapStart != UINT_MAX)
		{
	// All gaps?
		if (GapStart == 0)
			return;
		uns GapLength = ColCount - GapStart;
		OnTerminalGap(GapStart, GapLength);
		}
	}
