#include "evo.h"

void SeqTree()
	{
	const char *SeqFileName = RequiredValueOpt("seqtree");
	const char *TreeFileName = RequiredValueOpt("tree");
	const char *OutFileName = RequiredValueOpt("out");

	MicroEvolver MicroAncestor;
	MicroAncestor.FromFASTAFile(SeqFileName);
	MicroAncestor.Validate();

	SmallTree Tree;
	Tree.FromNewickFile(TreeFileName);
	if (Tree.GetNodeCount() < 2)
		Die("Tree must have at least two nodes");

	FILE *fOut = CreateStdioFile(OutFileName);

// Write placeholder header, update when done.
	EvoFileHeader OutEvoHdr;
	memset(&OutEvoHdr, 0, sizeof(OutEvoHdr));
	WriteStdioFile(fOut, &OutEvoHdr, sizeof(OutEvoHdr));

	const unsigned NodeCount = Tree.GetNodeCount();
	IntVec NodeIndexToMULIndex(NodeCount, UINT_MAX);

	OutEvoHdr.StartMagic = EvoStartHdrMagic;
	OutEvoHdr.TotalMULCount = g_TotalOutputMULCount;
	OutEvoHdr.LeafMULCount = g_LeafOutputMULCount;
	OutEvoHdr.TotalBaseCount = g_WrittenBaseCount;
	OutEvoHdr.LeafBaseCount = g_LeafBaseCount;
	OutEvoHdr.EndMagic = EvoEndHdrMagic;
	WriteStdioFile(fOut, 0, &OutEvoHdr, sizeof(OutEvoHdr));

	CloseStdioFile(fOut);
	}
