#include "stack.h"

#define	TRACE	0

void Stacker::OutputInconsistentCol(const OutputCol_t &Col) const
	{
#if	TRACE
	Log("\n");
	Log("OutputInconsistentCol\n");
	LogCol(Col);
	Log("\n");
#endif

	const unsigned BaseCount = SIZE(Col);
	assert(BaseCount >= 2);

	const BaseWithSign &FirstBase = Col[0];

	AlnInfo AI;
	StdStrVec Rows;
	AI.SetAttr(ALN_ATTR_UnalignedBlock, 0);

	Rows.resize(1);
	AI.Segs.resize(1);
	GCSeg &Seg = AI.Segs[0];
	Seg.GenomeIndex = FirstBase.Base.GenIndex;
	Seg.ChrId = FirstBase.Base.ChrId;
	Seg.lo = FirstBase.Base.Pos;
	Seg.hi = Seg.lo;
	Seg.Plus = FirstBase.Plus;
	GCSeg *CurrentSeg = &Seg;
	StdStr *CurrentRow = &Rows.back();
	char c = FirstBase.GetLetter();
	CurrentRow->push_back(c);

#if	TRACE
	Log("First base ");
	LogBWS(FirstBase);
	Log("\n");
	Log("First seg ");
	LogGCSeg(Seg);
	Log(" c=%c ", c);
	Log("\n");
#endif

// Note loop starts from 1 not 0
	for (unsigned BaseIndex = 1; BaseIndex < BaseCount; ++BaseIndex)
		{
		const BaseWithSign &PrevBWS = Col[BaseIndex-1];
		const BaseWithSign &BWS = Col[BaseIndex];
		assert(PrevBWS < BWS);
		char c = BWS.GetLetter();
#if	TRACE
		Log("\n");
		Log("BaseIndex %u\n", BaseIndex);
		Log("PrevBWS ");
		LogBWS(PrevBWS);
		Log("\n");
		Log("BWS     ");
		LogBWS(BWS);
		Log("\n");
#endif
		assert(PrevBWS < BWS);
		bool Adjacent = BWS.Adjacent(PrevBWS);
		if (Adjacent)
			{
			if (BWS.Plus != CurrentSeg->Plus)
				c = CompLetter(c);

		// Extend current segment
			if (BWS.Base.Pos == CurrentSeg->hi + 1)
				{
				++(CurrentSeg->hi);
				if (CurrentSeg->Plus)
					CurrentRow->push_back(c);
				else
					CurrentRow->insert(CurrentRow->begin(), c);
				}
			else if (BWS.Base.Pos + 1 == CurrentSeg->lo)
				{
				--(CurrentSeg->lo);
				if (CurrentSeg->Plus)
					CurrentRow->insert(CurrentRow->begin(), c);
				else
					CurrentRow->push_back(c);
				}
			else
				asserta(false);

#if	TRACE
			Log("Extend");
#endif
			}
		else
			{
		// Start new segment
			GCSeg NewSeg;
			NewSeg.GenomeIndex = BWS.Base.GenIndex;
			NewSeg.ChrId = BWS.Base.ChrId;
			NewSeg.lo = BWS.Base.Pos;
			NewSeg.hi = NewSeg.lo;
			NewSeg.Plus = BWS.Plus;
			AI.Segs.push_back(NewSeg);
			const unsigned SegCount = SIZE(AI.Segs);
			CurrentSeg = &AI.Segs[SegCount-1];

			StdStr NewRow;
			Rows.push_back(NewRow);
			CurrentRow = &Rows.back();
			CurrentRow->push_back(c);
#if	TRACE
			Log("New");
#endif
			}
#if	TRACE
		Log(" Seg=");
		LogGCSeg(*CurrentSeg);
		Log(" Row=%s", CurrentRow->c_str());
		Log("\n");
#endif
		}
	const unsigned RowCount = SIZE(Rows);
	asserta(RowCount == SIZE(AI.Segs));

	unsigned LongestRowLength = 0;
	FORIX(Row)
		{
		const StdStr &Row = Rows[RowIndex];
		unsigned Length = SIZE(Row);
		if (Length > LongestRowLength)
			LongestRowLength = Length;
		}

	FORIX(Row)
		{
		StdStr &Row = Rows[RowIndex];
		unsigned Length = SIZE(Row);
		unsigned Diff = LongestRowLength - Length;
		for (unsigned i = 0; i < Diff; ++i)
			Row.push_back('-');
		assert(SIZE(Row) == LongestRowLength);
		}

	if (g_LogInconsistentAlns)
		LogAIRows(AI, Rows);

	ptrOut->AddAln(AI, Rows);
	}
