#include "evo.h"

void TestEvo()
	{
	const char *AnFASTAFileName = "as.fa";
	const char *AnGenomeName= "an";
	const char *EvGenomeName= "ev";
	const char *MULFileName = "testevo.mul";
	const char *AnFileName = "testevo_an.evo";
	const char *EvFileName = "testevo_ev.evo";
	const char *RevFileName = "testevo.rev";
	const char *EvFASTAFileName = "testevo_ev.fa";
	const char *AnnotsFileName = "testevo_annots.gff";
	const char *MicrosatsFileName = "testevo_sats.gff";

	FILE *fMUL = CreateStdioFile(MULFileName);

	DoFASTA2Evo(AnFASTAFileName, AnFileName, AnGenomeName);

	vector<gpos_t> ChrLengths;
	ChrLengths.push_back(99);

	BigEvolver Big;
	Big.InitFromChrLengths(ChrLengths);
	Big.BigInvert(33, 33);
	Big.Validate();
	Big.ToFile(fMUL);
	CloseStdioFile(fMUL);
	fMUL = 0;

	DoMicroEvolve(AnFileName, MULFileName, EvFileName, EvGenomeName,
	  MicrosatsFileName, AnnotsFileName, 0);
	DoEvoToRev(AnFileName, EvFileName, RevFileName);
	DoEvoToFASTA(EvFileName, EvFASTAFileName);
	}
