#include "icevo.h"
#include "ratemgr.h"

extern RateMgr *g_InterChrMoveRateMgr;

bool InterChrEvolver::Try_InterChrMove()
	{
	gpos_t FromPos = GetRandomPos();
	if (FromPos == GPOS_T_MAX)
		return false;

	gpos_t ToPos = GetRandomPosDifferentChr(FromPos);
	if (ToPos == GPOS_T_MAX)
		return false;

	gpos_t MoveLength = g_InterChrMoveRateMgr->GetLength();

	if (!RangeExists(FromPos, MoveLength))
		return false;

	if (!RangeExists(ToPos, 2))
		return false;

	if (PosInRange(ToPos, FromPos, MoveLength))
		return false;

	bool Accept = AcceptInsert(ToPos, 2);
	if (!Accept)
		return true;

	Accept = AcceptMove(FromPos, MoveLength);
	if (!Accept)
		return true;

	Move(FromPos, ToPos, MoveLength);
	g_InterChrMoveRateMgr->StoreResult((EVENT_RESULT) 0, MoveLength);
	return true;
	}
