#include "bndfile.h"
#include "utils.h"

static void PathLengths(const char *Path, coord_t *ptrLength0, coord_t *ptrLength1)
	{
	coord_t Length0 = 0;
	coord_t Length1 = 0;
	while (char c = *Path++)
		switch (c)
			{
		case 'M':
			++Length0;
			++Length1;
			break;
		case 'D':
			++Length0;
			break;
		case 'I':
			++Length1;
			break;
		default:
			Die("Path lengths invalid char %c in path", c);
			}
	*ptrLength0 = Length0;
	*ptrLength1 = Length1;
	}

void ValidateHitPath(const SegPair &Hit, const char *Path)
	{
	coord_t Length0_Hit = Hit.Segs[0].Length();
	coord_t Length1_Hit = Hit.Segs[1].Length();

	coord_t Length0_Path;
	coord_t Length1_Path;
	PathLengths(Path, &Length0_Path, &Length1_Path);

	if (Length0_Hit != Length0_Path || Length1_Hit != Length1_Path)
		{
		Log("Path=%s\n", Path);
		Log("Hit=");
		LogSPN(Hit);
		Die("ValidateHitPath: Len0_Hit=%u Len0_Path=%u, Len1_Hit=%u Len1_Path=%u",
		  Length0_Hit, Length0_Path, Length1_Hit, Length1_Path);
		}
	}
