#ifndef ALIGN_PARAMS_H
#define ALIGN_PARAMS_H

#include "types.h"

const coord_t DEFAULT_MAXLENGTH = 2000;

enum ALIGN_METHOD
	{
	ALIGN_METHOD_Invalid = 0,
	ALIGN_METHOD_HM = 1,
	ALIGN_METHOD_NWGlobal = 2,
	ALIGN_METHOD_NWLocal = 3,
	ALIGN_METHOD_Hybrid = 4,
	ALIGN_METHOD_Skip = 5,
	ALIGN_METHOD_Max = ALIGN_METHOD_Skip
	};

extern score_t MATCH;
extern score_t MISMATCH;
extern score_t GAPOPEN;
extern score_t GAPEXTEND;
extern score_t UGAPEXTEND;
extern score_t MINSCORE;
extern score_t N_SCORE;
extern double MINCOLSCORE;
extern unsigned SLIDE;
extern unsigned SLIDEOFF;
extern unsigned MINBADLENGTH;

extern unsigned MINLENGTH;
extern unsigned MAXAREA;
extern unsigned MINRADIUS;

extern bool g_PlusOnly;
extern bool g_Pass2;
extern bool g_TopHitOnly;
extern bool g_AcceptAll;
extern bool g_BandMasked;

extern double g_BandFactor;

extern ALIGN_METHOD g_AlignMethod;

#define	TERMGAP	GAPEXTEND

#endif	// ALIGN_PARAMS_H
