#include "nw.h"

score_t BestSubString(const score_t s[], unsigned ls, unsigned *ptrBestStart,
  unsigned *ptrBestEnd);

score_t BestSubAln(const char *A, unsigned LA, const char *B, unsigned LB,
  const char *Path, unsigned *ptrStart, unsigned *ptrEnd)
	{
	const unsigned ColCount = (unsigned) strlen(Path);
	score_t *ColScores = myalloc(score_t, ColCount);

	unsigned i = 0;
	unsigned j = 0;
	char cA = '?';
	char cB = '?';
	for (unsigned Col = 0; Col < ColCount; ++Col)
		{
		const char PrevType = (Col == 0 ? 'S' : Path[Col-1]);
		const char Type = Path[Col];

		score_t ColScore = -1;
		switch (Type)
			{
		case 'M':
		// xM
			{
			cA = A[i];
			cB = B[j];
			ColScore = SUBST(cA, cB);

			++i;
			++j;
			break;
			}

		case 'D':
			{
			cA = A[i];
			cB = '-';
			switch (PrevType)
				{
			case 'S':
			// SD
				ColScore = TERMGAP;
				break;

			case 'M':
			// MD
				ColScore = (i == LA - 1 ? TERMGAP : GAPOPEN);
				break;

			case 'D':
			// DD
				ColScore = GAPEXTEND;
				break;

			case 'I':
			// DI
				ColScore = GAPOPEN;
				break;

			default:
				Die("BestSubAln: %cD", PrevType);
				}

			++i;
			break;
			}

		case 'I':
			{
			switch (PrevType)
				{
			case 'S':
			// SI
				ColScore = TERMGAP;
				break;

			case 'M':
			// MI
				ColScore = (j == LB - 1 ? TERMGAP : GAPOPEN);
				break;

			case 'I':
			// II
				ColScore = GAPEXTEND;
				break;

			// ID
			case 'D':
				ColScore = GAPOPEN;
				break;

			default:
				Die("BestSubAln: %cI", PrevType);
				}

			++j;
			break;
			}

		default:
			Die("BestSubAln: invalid type %c", Type);
			}
		ColScores[Col] = ColScore;
		}

	score_t Score = BestSubString(ColScores, ColCount, ptrStart, ptrEnd);

	if (Score > 0)
		{
		if (Path[*ptrStart] != 'M' || Path[*ptrEnd] != 'M')
			Die("BestSubAln, bug: must start and end with M");
		}

	myfree(ColScores);
	return Score;
	}
