#ifndef BMTYPES_H
#define BMTYPES_H

typedef signed long long int sint64;

typedef sint64 excess_t;
typedef sint64 price_t;

#define MAX_64 (0x7fffffffffffffffLL)
#define MAX_32 (0x7fffffff)
#define PRICE_MAX MAX_64

struct arc;
struct node;

//Typical sizeof(arc) in 32-bit archs: 20 bytes
struct arc
{
	int              r_cap;           /* residual capasity */
	price_t          cost;            /* cost of the arc*/
	node             *head;           /* head node */
	arc              *sister;         /* opposite arc */
};

//Typical sizeof(node) in 32-bit archs: 48 bytes
struct node
{
	arc              *first;           /* first outgoing arc */
	arc              *current;         /* current outgoing arc */
	arc              *suspended;
	excess_t         excess;           /* excess of the node */
	price_t          price;            /* distance from a sink */
	node             *q_next;          /* next node in push queue */
	node             *b_next;          /* next node in bucket-list */
	node             *b_prev;          /* previous node in bucket-list */
	int              rank;             /* bucket number */
	int              inp;              /* auxilary field */
};

struct bucket
{
	node             *p_first;         /* 1st node with positive excess 
	                                      or simply 1st node in the buket */
};

#endif
