#ifndef CHRINFO_H
#define	CHRINFO_H

#include <string>
#include <stdio.h>
#include "types.h"
#include "iface.h"

struct ChrInfo
	{
	void Create(unsigned Id, const std::string &Name, coord_t Length)
		{
		m_Id = Id;
		m_Name = Name;
		m_Length = Length;
		}

	void FromFile(FILE *f);

	void ToFile(FILE *f) const;

	unsigned GetId() const
		{
		return m_Id;
		}

	const std::string &GetName() const
		{
		return m_Name;
		}

	void SetName(const std::string &Name)
		{
		m_Name = Name;
		}

	coord_t GetLength() const
		{
		return m_Length;
		}

	void SetLength(coord_t Length)
		{
		m_Length = Length;
		}

	bool operator==(const ChrInfo &rhs) const;

	void LogMe() const;

private:
	unsigned m_Id;
	coord_t m_Length;
	std::string m_Name;
	};

#endif	// CHRINFO_H
