#ifndef	CHRPAIRINDEX_H
#define CHRPAIRINDEX_H

#include <stdio.h>
#include <vector>
#include <algorithm>
#include "myunistd.h"
#include "types.h"

struct ChrPairIndexEntry
	{
	unsigned ChrIndex1;
	unsigned ChrIndex2;		
	uint64 FilePos;
	};

class ChrNameIndex;
const unsigned ChrPairIndexMagic = 0xa11111;

class ChrPairIndex : public std::vector<ChrPairIndexEntry>
	{
public:
	void FromFile(FILE *f);
	void ToFile(FILE *f);
	void Add(unsigned ChrIndex1, unsigned ChrIndex2, off_t Pos);
	bool Lookup(unsigned ChrIndex1, unsigned ChrIndex2, off_t *ptrPos) const;
	void Sort();
	};

bool ChrPairOpts(const ChrNameIndex &Index1, const ChrNameIndex &Index2,
  unsigned *ptrChrIndex1, unsigned *ptrChrIndex2, bool Required = false);

#endif // CHRPAIRINDEX_H
