#include "utils.h"
#include "wordhist.h"
#include "getopts.h"
#include "xlat.h"

void DumpHist()
	{
	const char *HistFileName = RequiredValueOpt("dumphist");
	const char *OutFileName = RequiredValueOpt("out");
	bool All = FlagOpt("all");

	WordHist WH;
	WH.FromFile(HistFileName);

	ALPHA Alpha = WH.GetAlpha();
	unsigned WordSize = WH.GetWordSize();
	uint64 WordCount = CalcWordCount(Alpha, WordSize);

	FILE *fOut = CreateStdioFile(OutFileName);
	for (uint64 Word = 0; Word < WordCount; ++Word)
		{
		unsigned Count = WH.GetCount(Word);
		if (Count == 0 && !All)
			continue;
		const char *Str = 0;
		if (Alpha == ALPHA_Nucleo)
			Str = NucWordToStr(Word, WordSize);
		else if (Alpha == ALPHA_Amino)
			Str = AminoWordToStr(Word, WordSize);
		else
			Die("Alphabet not supported %d", Alpha);
		fprintf(fOut, "%s %u\n", Str, Count);
		}
	CloseStdioFile(fOut);
	}
