#include "revfile.h"
#include "utils.h"
#include "getopts.h"

#define ReadData(v)		ReadStdioFile(f, &v, (unsigned) sizeof(v))

void DumpRevHdr()
	{
	std::string RevFileName = RequiredValueOpt("dumprevhdr");

	FILE *f = OpenStdioFile(RevFileName.c_str());

	RevFileHdr Hdr;
	ReadData(Hdr);

	Dump("\n");
	Dump("Header:\n");
	Dump("Magic          %0x\n", (unsigned) Hdr.Magic);
	Dump("GenomeCount    %s\n", uint32tostr(Hdr.GenomeCount));
	Dump("AlnInfoCount   %s\n", uint32tostr(Hdr.AlnInfoCount));
	Dump("AlnCount       %s (non-compressed only)\n", uint32tostr(Hdr.AlnCount));
	Dump("GenomesPos     %s\n", uint64tostr(Hdr.GenomesPos));
	Dump("AlnInfoTOCPos  %s\n", uint64tostr(Hdr.AlnInfoTOCPos));
	Dump("AlnTOCPos      %s\n", uint64tostr(Hdr.AlnTOCPos));
	Dump("HashTablePos   %s\n", uint64tostr(Hdr.HashTablePos));
	Dump("HashTableBytes %s\n", uint32tostr(Hdr.HashTableBytes));
	Dump("HashTableSize  %s\n", uint32tostr(Hdr.HashTableEntryCount));
	Dump("SeqCount       %s\n", uint64tostr(Hdr.SeqCount));
	Dump("SeqTOCPos      %s\n", uint64tostr(Hdr.SeqTOCPos));
	Dump("AlnPos         %s\n", uint64tostr(Hdr.AlnsPos));
	Dump("EndMagic       %0x\n", (unsigned) Hdr.EndHdrMagic);

	CloseStdioFile(f);
	}
