#if !defined(FLT) || !defined(POS)
#error	"evoscalarparams.h: FLT or POS not defined"
#endif

//		Name							Default		Min			Max

FLT(	AC_Rate,						0.2,		0.0,		1000000		)
FLT(	AG_Rate,						0.6,		0.0,		1000000		)
FLT(	AT_Rate,						0.2,		0.0,		1000000		)

FLT(	CA_Rate,						0.2,		0.0,		1000000		)
FLT(	CG_Rate,						0.2,		0.0,		1000000		)
FLT(	CT_Rate,						0.6,		0.0,		1000000		)

FLT(	CpG_C_to_T_Ratio,				10.0,		0.0,		1000000		)
FLT(	CpGFraction,					0.1,		0,			10			)
POS(	MinCpGSweeps,					10,			0,			10000		)

// Events that do not have a length distribution
FLT(	TandemExpandRate,				0.0,		0.0,		100.0		)
FLT(	TandemContractRate,				0.0,		0.0,		100.0		)
FLT(	ChrFuseRate,					0.0,		0.0,		100.0		)
FLT(	ChrSplitRate,					0.0,		0.0,		100.0		)
FLT(	RecipTranslocRate,				0.0,		0.0,		100.0		)
FLT(	NonRecipTranslocRate,			0.0,		0.0,		100.0		)

FLT(	CreateNontermUTRRate,			0.0,		0.0,		FLT_MAX		)
FLT(	CreateTermUTRRate,				0.0,		0.0,		FLT_MAX		)
FLT(	DeleteUTRRate,					0.0,		0.0,		FLT_MAX		)

FLT(	CreateCDSRate,					0.0,		0.0,		FLT_MAX		)
FLT(	DeleteCDSRate,					0.0,		0.0,		FLT_MAX		)

FLT(	MoveUTRTermRate,				0.0,		0.0,		FLT_MAX		)

FLT(	MoveStartCodonIntoUTRRate,		0.0,		0.0,		FLT_MAX		)
FLT(	MoveStartCodonIntoCDSRate,		0.0,		0.0,		FLT_MAX		)
FLT(	MoveStopCodonIntoUTRRate,		0.0,		0.0,		FLT_MAX		)
FLT(	MoveStopCodonIntoCDSRate,		0.0,		0.0,		FLT_MAX		)

FLT(	MoveCDSDonorIntoIntronRate,		0.0,		0.0,		FLT_MAX		)
FLT(	MoveDonorIntoCDSRate,			0.0,		0.0,		FLT_MAX		)
FLT(	MoveCDSAcceptorIntoIntronRate,	0.0,		0.0,		FLT_MAX		)
FLT(	MoveAcceptorIntoCDSRate,		0.0,		0.0,		FLT_MAX		)

FLT(	MoveUTRDonorIntoIntronRate,		0.0,		0.0,		FLT_MAX		)
FLT(	MoveDonorIntoUTRRate,			0.0,		0.0,		FLT_MAX		)
FLT(	MoveUTRAcceptorIntoIntronRate,	0.0,		0.0,		FLT_MAX		)
FLT(	MoveAcceptorIntoUTRRate,		0.0,		0.0,		FLT_MAX		)

FLT(	ChangeGeneSpeedRate,			0.0,		0.0,		FLT_MAX		)
FLT(	ChangeNGESpeedRate,				0.0,		0.0,		FLT_MAX		)

FLT(	CreateNXERate,					0.0,		0.0,		FLT_MAX		)
FLT(	DeleteNXERate,					0.0,		0.0,		FLT_MAX		)
FLT(	MoveNXERate,					0.0,		0.0,		FLT_MAX		)

FLT(	CreateNGERate,					0.0,		0.0,		FLT_MAX		)
FLT(	DeleteNGERate,					0.0,		0.0,		FLT_MAX		)
FLT(	MoveNGERate,					0.0,		0.0,		FLT_MAX		)

FLT(	CreateCpGIslandRate,			0.0,		0.0,		FLT_MAX		)
FLT(	DeleteCpGIslandRate,			0.0,		0.0,		FLT_MAX		)
FLT(	MoveCpGIslandRate,				0.0,		0.0,		FLT_MAX		)
POS(	MaxCpGInsert,					50,			0,			1000000		)

POS(	MinMoveInvertLength,			0,			0,			1000000		)
POS(	MinCopyInvertLength,			0,			0,			1000000		)
POS(	MinTandemInvertLength,			100,		0,			2000000000	)

FLT(	MoveInvertProb,					0.5,		0.0,		1.0			)
FLT(	CopyInvertProb,					0.5,		0.0,		1.0			)
FLT(	TandemInvertProb,				0.1,		0.0,		1.0			)

POS(	MinIntronLength,				17,			3,			9999999		)
POS(	MinTandemAnnot,					8,			1,			999999		)
POS(	MaxTandemAnnot,					128,		1,			999999		)
POS(	MinChrLength,					100,		1,			2000000000	)
POS(	MaxChrLength,					200000000,	1,			2000000000	)
POS(	MinChrCount,					2,			1,			1000000		)
POS(	MaxChrCount,					50,			1,			1000000		)
POS(	MaxChrName,						32,			1,			1000000		)

POS(	MaxMoveStartStopCodons,			33,			1,			1000000		)
POS(	MaxMoveSpliceBases,				100,		1,			1000000		)
POS(	MoveNGEMeanDist,				5,			1,			1000000		)
FLT(	MoveNGEStdDevDist,				2,			1,			1000000		)
POS(	MoveCpGIslandMeanDist,			128,		1,			1000000		)
FLT(	MoveCpGIslandStdDevDist,		64,			1,			1000000		)
POS(	MoveNXEMeanDist,				5,			1,			1000000		)
FLT(	MoveNXEStdDevDist,				2,			1,			1000000		)
POS(	PromoterCpGSlopBases,			32,			1,			1000000		)
POS(	CreateExonLengthSlop,			9,			1,			1000000		)
POS(	MoveUTRTermMeanDist,			5,			1,			1000000		)
POS(	MoveUTRTermDistStdDev,			2,			1,			1000000		)
POS(	MinUTRBases,					100,		1,			1000000		)

// For generating annots
FLT(	MeanInterGeneFract,				0.5,		0.0,		0.5			)
POS(	MaxGeneMargin,					1000000,	1,			500000000	)
FLT(	StdDevInterGeneFract,			0.2,		0.0,		1.0			)
FLT(	GenomeNCCEPct,					10.0,		0.0,		100.0		)
FLT(	ClumpShufflePct,				25.0,		0.0,		100.0		)
FLT(	CEClumpMeanLength,				32.0,		0.0,		100.0		)
FLT(	CEClumpLengthStdDev,			16.0,		0.0,		100.0		)
FLT(	AccelIncrementMean,				2,			0.0,		100.0		)
FLT(	AccelIncrementStdDev,			1,			0.0,		100.0		)
FLT(	AminoAcidProbMultiplier,		2.0,		0.0,		100.0		)

FLT(	NCCEMeanMean,					0.8,		0.0,		1.0			)
FLT(	NCCEMeanStdDev,					0.2,		0.0,		1.0			)

FLT(	CDSMeanMean,					0.5,		0.0,		1.0			)
FLT(	CDSMeanStdDev,					0.4,		0.0,		1.0			)

FLT(	GeneCDSToNCEAccel,				3.5,		0.0,		100.0		)

// Misc non-biological
POS(	EventFailTries,					5,			1,			1000		)
FLT(	MaxRateApproxErrPct,			20.0,		1.0,		500.0		)
POS(	MinAlnLength,					1,			1,			1000000		)
POS(	MinCopyAln,						100,		1,			1000000000	)

#undef FLT
#undef POS
