#ifndef FASTASTR_H
#define FASTASTR_H

const unsigned BUFFER_SIZE = 64*1024;
//const unsigned BUFFER_SIZE = 16;	// for testing on small data

class FastaStream
	{
public:
	FastaStream();
	virtual ~FastaStream();

public:
	void Open(const char *FileName, unsigned WordLength = 0);
	void Close();
	bool GetNextNucWord(uint64 *ptrWord);
	bool GetNextAminoWord(uint64 *ptrWord);
	bool GetNextSeqChar(unsigned char *ptrc);
	bool GetNextChar(unsigned char *ptrc);
	bool GetNextSeq(std::vector<char> &Label, std::vector<unsigned char> &Seq);
	off_t GetFilePos()
		{
		return m_FilePos;
		}
	off_t GetFileSize()
		{
		return m_FileSize;
		}
	void SetAmino(bool Amino)
		{
		m_Amino = Amino;
		}
	void SetXlet(bool Xlat)
		{
		m_Amino = Xlat;
		}
	uint64 GetTotalChars() const
		{
		return m_TotalChars;
		}

private:
	FILE *m_f;
	unsigned m_WordLength;
	char *m_Buffer;
	off_t m_FilePos;
	off_t m_FileSize;
	unsigned m_BytesTransferred;
	unsigned m_BytesInBuffer;
	unsigned m_BufferPos;
	bool m_Label;
	unsigned m_CharCount;
	uint64 m_Word;
	uint64 m_Mask;
	uint64 m_20w;
	unsigned char m_LastChar;
	bool m_Amino;
	bool m_Xlat;
	uint64 m_TotalChars;
	};

#endif // FASTASTR_H
