#include <stdio.h>
#include "align_params.h"
#include "getopts.h"
#include "utils.h"
#include "scoremx.h"

//static ALIGN_METHOD StrToAlignMethod(const char *Str)
//	{
//	if (streq(Str, "hm"))
//		return ALIGN_METHOD_HM;
//	if (streq(Str, "nwglobal"))
//		return ALIGN_METHOD_NWGlobal;
//	if (streq(Str, "nwlocal"))
//		return ALIGN_METHOD_NWLocal;
//	if (streq(Str, "hybrid"))
//		return ALIGN_METHOD_Hybrid;
//	Die("Invalid -method %s", Str);
//	return ALIGN_METHOD_Invalid;
//	}

void GetAlignParams()
	{
	int MAXLENGTH = DEFAULT_MAXLENGTH;
	SignedIntOpt("maxlen", &MAXLENGTH);
	MAXAREA = MAXLENGTH*MAXLENGTH;

	IntOpt("minlength", &MINLENGTH);
	IntOpt("minradius", &MINRADIUS);
	FloatOpt("bandfactor", &g_BandFactor);
	FloatOpt("mincolscore", &MINCOLSCORE);

	IntOpt("slide", &SLIDE);
	IntOpt("slideoff", &SLIDEOFF);

#if	INTEGER_DP
	SignedIntOpt("minscore", &MINSCORE);
	SignedIntOpt("match", &MATCH);
	SignedIntOpt("mismatch", &MISMATCH);
	SignedIntOpt("gapopen", &GAPOPEN);
	SignedIntOpt("gapextend", &GAPEXTEND);
#else
	double tmpMATCH = (double) MATCH;
	double tmpMISMATCH = (double) MISMATCH;
	double tmpGAPOPEN = (double) GAPOPEN;
	double tmpGAPEXTEND = (double) GAPEXTEND;
	double tmpMINSCORE = (double) MINSCORE;

	FloatOpt("match", &tmpMATCH);
	FloatOpt("mismatch", &tmpMISMATCH);
	FloatOpt("gapopen", &tmpGAPOPEN);
	FloatOpt("gapextend", &tmpGAPEXTEND);
	FloatOpt("minscore", &tmpMINSCORE);

	MATCH = (score_t) tmpMATCH;
	MISMATCH = (score_t) tmpMISMATCH;
	GAPOPEN = (score_t) tmpGAPOPEN;
	GAPEXTEND = (score_t) tmpGAPEXTEND;
	MINSCORE = (score_t) tmpMINSCORE;
#endif

	InitScoreMatrix(MATCH, MISMATCH, N_SCORE);

	const char *MatrixFileName = ValueOpt("matrix");
	if (0 != MatrixFileName)
		{
		FILE *f = OpenStdioFile(MatrixFileName);
		ReadScoreMx(f, &GAPOPEN, &GAPEXTEND);
		}

	if (GAPOPEN > 0)
		Die("gapopen should be <= 0");
	if (GAPEXTEND > 0)
		Die("gapextend should be <= 0");
	if (MATCH < 0)
		Die("match should be > 0");
	if (MISMATCH > 0)
		Die("mismatch should be < 0");
	}
