#include "ice.h"
#include "event.h"
#include "ratemgr.h"
#include "evomodel.h"

extern RateMgr *g_InterChrCopyRateMgr;
extern RateMgr *g_InterChrMoveRateMgr;

void InterChrEvolver::ComputeEventRates()
	{
	m_IntegratedEventRates.clear();
	m_IntegratedEventRates.resize(EventTypeCount, 0);
	gpos_t GenomeLength = GetLength();

	m_IntegratedEventRates[EVENT_TYPE_InterChrCopy] =
	  GenomeLength*g_InterChrCopyRateMgr->GetTotalRate();

	m_IntegratedEventRates[EVENT_TYPE_InterChrMove] =
	  GenomeLength*g_InterChrMoveRateMgr->GetTotalRate();

	m_IntegratedEventRates[EVENT_TYPE_ChrSplit] = P_ChrSplitRate;
	m_IntegratedEventRates[EVENT_TYPE_ChrFuse] = P_ChrFuseRate;
	m_IntegratedEventRates[EVENT_TYPE_RecipTransloc] = P_RecipTranslocRate;
	m_IntegratedEventRates[EVENT_TYPE_NonRecipTransloc] = P_NonRecipTranslocRate;
	}

double InterChrEvolver::GetTotalIntegratedRate() const
	{
	double Total = 0;
	asserta(SIZE(m_IntegratedEventRates) == EventTypeCount);
	for (unsigned e = 0; e < EventTypeCount; ++e)
		Total += m_IntegratedEventRates[e];
	return Total;
	}

double InterChrEvolver::GetAvgWaitTime() const
	{
	double TotalIntegratedRate = GetTotalIntegratedRate();
	return 1.0/TotalIntegratedRate;
	}
