#include "evomodel.h"
#include "getopts.h"
#include "utils.h"

void SetModel(const char *FileName);
void LogDists();
void LogNucMx();
void LogAAMx();
void LogRateParams();
void LogGeneDupeParams();

static void LogParamText(const char *Text)
	{
	if (strlen(Text) == 0)
		return;
	Log("\n");
	Log("# ");
	while (char c = *Text++)
		{
		if (c == '\n' && *Text != 0)
			Log("\n# ");
		else
			Log("%c", c);
		}
	Log("\n");
	}

static void LogEvoParams()
	{
	Log("\n");

#define POS(x, v, min, max)				\
	extern const char *g_ParamText_##x;	\
	LogParamText(g_ParamText_##x);		\
	Log(#x" = %"PF"\n", P_##x);

#define FLT(x, v, min, max)				\
	extern const char *g_ParamText_##x;	\
	LogParamText(g_ParamText_##x);		\
	if ((unsigned) P_##x == P_##x)		\
		Log(#x" = %.1f\n", P_##x);		\
	else								\
		Log(#x" = %g\n", P_##x);

#include "evoscalarparams.h"

	LogAAMx();
	LogRateParams();
	LogGeneDupeParams();
	Log("##\n");
	}

void LogModel()
	{
	const char *ModelFileName = ValueOpt("model");
	SetModel(ModelFileName);
	LogEvoParams();
	if (FlagOpt("dump"))
		LogDists();
	}
