#ifndef MAFFILE_H
#define MAFFILE_H

#include "types.h"
#include "intlist.h"
#include "types.h"
#include <stdio.h>

const double NO_SCORE = -1e-10;

class MAFFile
	{
public:
	MAFFile();
	virtual ~MAFFile();

public:
	void Create(const char *FileName, const char *CmdLine = 0,
	  const char *Scoring = 0, const char *Program = 0);
	void Open(const char *FileName);
	void Rewind();
	void Close();
	void SetPlusCoords(bool On) { m_PlusCoords = On; }

	void AppendAln(const PosVec &Los, const PosVec &His, const BoolVec &Pluses,
	  const StdStrVec &Rows, const StdStrVec &SeqNames, const PosVec &SeqLengths,
	  double Score = 0, unsigned Pass = 0, const char *Comment = 0);
	bool GetNextAln(PosVec &Los, PosVec &His, BoolVec &Pluses, StdStrVec &Rows,
	  StdStrVec &SeqNames, PosVec &SeqLengths, double &Score);
	void Parse_s_Line(const char *Buffer, StdStrVec &SeqNames, PosVec &SeqLengths,
	  PosVec &Los, IntVec &His, BoolVec &Pluses, StdStrVec &Rows);
	void Parse_a_Line(const char *Buffer, double &Score);
	void SetSubCmt(const std::string &Cmt) { m_SubCmt = Cmt; }
	off64_t GetFileSize() const;
	off64_t GetFilePos() const;
	double ComputePctId(const StdStrVec &Rows) const;

private:
	FILE *m_f;
	bool m_PlusCoords;
	std::string m_SubCmt;
	};

#endif	// MAFFILE_H
