#include "multix.h"

bool MakeSubSeg(const GCSeg &Seg, const StdStr &Row, GCSeg &SubSeg,
  StdStr &SubRow, unsigned StartColIndex, unsigned EndColIndex)
	{
#if	TRACE
	Log("MakeSubSeg StartColIndex %u EndColIndex %u\n", StartColIndex, EndColIndex);
	Log("Seg: ");
	LogGCSeg(Seg);
	Log("\n");
	Log("Row: ");
	Log("%.64s", Row.c_str());
	if (SIZE(Row) > 64)
		Log("...");
	Log("\n");
#endif
	SubSeg = Seg;

	coord_t Pos = Seg.Plus ? Seg.lo : Seg.hi;
	for (unsigned ColIndex = 0; ColIndex < StartColIndex; ++ColIndex)
		{
		char c = Row[ColIndex];
		if (c != '-')
			{
			if (Seg.Plus)
				++Pos;
			else
				{
				asserta(ColIndex + 1 == StartColIndex || Pos > 0);
				--Pos;
				}
			}
		}

	SubSeg.lo = COORD_T_MAX;
	SubSeg.hi = COORD_T_MAX;
	for (unsigned ColIndex = StartColIndex; ColIndex <= EndColIndex; ++ColIndex)
		{
		char c = Row[ColIndex];
		if (c != '-')
			{
			if (Seg.Plus)
				{
				if (SubSeg.lo == COORD_T_MAX)
					SubSeg.lo = Pos;
				SubSeg.hi = Pos;
				++Pos;
				}
			else
				{
				if (SubSeg.hi == COORD_T_MAX)
					SubSeg.hi = Pos;
				SubSeg.lo = Pos;
				asserta(ColIndex == EndColIndex || Pos > 0);
				--Pos;
				}
			}
		SubRow.push_back(c);
		}

// All gaps?
	if (SubSeg.lo == COORD_T_MAX || SubSeg.hi == COORD_T_MAX)
		return false;

	asserta(SubSeg.hi != COORD_T_MAX && SubSeg.hi != COORD_T_MAX);

	unsigned SubSeqLength = GetUngappedSeqLength(SubRow);
	unsigned SubSegLength = (unsigned) SubSeg.GetLength();
	if (SubSeqLength != SubSegLength)
		{
		Log("\n");
		Log("SubSeg: ");
		LogGCSeg(SubSeg);
		Log("\n");
		Log("SubRow: %.64s\n", SubRow.c_str());
		Die("MakeSubAln, assert failed SubRow length %u, SubSeg length %u",
		  SubSeqLength, SubSegLength);
		}
	return true;
	}
