#ifndef SEGBAGAI_H
#define SEGBAGAI_H

#include "alninfo.h"

// Key is midpoint of seg
typedef std::map<coord_t, GCSeg> SegMap;
typedef SegMap::iterator SegMapIter;
typedef SegMap::const_iterator SegMapCIter;
typedef SegMap::value_type SegMapValue;

// A bag of non-overlapping segments
class SegBag
	{
public:
// Update
	void InsertSeg(const GCSeg &s);
	void DeleteSeg(coord_t Pos);
	void DeleteSeg(const GCSeg &s);
	void Subtract(const GCSeg &s, coord_t MinLength, double CovFract = 0.999);

// Read
	unsigned GetSegCount() const;
	bool GetSeg(coord_t Pos, GCSeg *ptrs) const;
	bool GetNearestSeg(coord_t Pos, coord_t *ptrSegPos) const;
	bool GetNearestSeg(coord_t Pos, SegMapCIter *pIter) const;
	coord_t Coverage(const GCSeg &s) const;

	void LogMe() const;

// private:
	SegMap m_Segs;
	};

#endif	// SEGBAGAI_H
