#include "types.h"
#include "revfile.h"
#include "getopts.h"

void ShowGenomeSizes()
{
	const char *InFileName = RequiredValueOpt("showgenomesizes");

	RevFile In;
	In.Open(InFileName);

	for (unsigned i = 0; i != In.GetGenomeCount(); ++i)
	{
		uint64 GenomeSize = In.GetGenomeInfo(i).GetLength64();
		printf("%"UINT64_PRINTF"\t%s\n", GenomeSize, In.GetGenomeName(i).c_str());
	}

	In.Close();
}

void ShowChrSizes()
{
	const char *InFileName = RequiredValueOpt("showchrsizes");

	RevFile In;
	In.Open(InFileName);

	unsigned GenIndex = 0;
	IntOpt("genid", &GenIndex);

	const GenInfo &GI = In.GetGenomeInfo(GenIndex);

	unsigned n = GI.GetChrCount();
	printf("%u\n", n);

	for (unsigned i = 0; i != n; i++)
	{
		const ChrInfo &CI = GI.GetChrInfoByIndex(i);
		printf("%u\t%u\t%s\n", CI.GetId(), CI.GetLength(), CI.GetName().c_str());
	}

	In.Close();
}
