#ifndef SIX_H
#define SIX_H

#include "revfile.h"
#include "ivtree.h"

// Six=Seg interval index

// GCSeg "extended" with a reference back to
// the AI that contains it (like AlnInfoX).
struct GCSegX
	{
	unsigned AIIndex;
	GCSeg Seg;

	bool operator==(const GCSegX &rhs) const
		{
		return Seg == rhs.Seg && AIIndex == rhs.AIIndex;
		}
	
	Interval operator()() const
		{
		return Interval(Seg.lo, Seg.hi);
		}
	};

typedef std::vector<GCSegX> GCSegXVec;

typedef std::vector<GCSegX> SVVec;

typedef IvTree<GCSegX, coord_t> IvTree_Six;

struct Six : public IvTree_Six
	{
	Six() : ptrRevFile(0), GenIndex(UINT_MAX), ChrId(UINT_MAX)
		{
		}

	const RevFile *ptrRevFile;
	unsigned GenIndex;
	unsigned ChrId;
	};

typedef std::vector<Six> SixVec;
typedef std::vector<SixVec> SixVecVec;
typedef std::vector<SixVecVec> SixVecVecVec;

void MakeSixes(const RevFile &Rev, SixVecVec &Indexes);
void SixGetOverlaps(const Six &Index, const Interval &Iv, GCSegXVec &Segs);

#endif // SIX_H
