#include "evolver.h"
#include "myrand.h"

double AccelProb(double p, double f);
uint8 ProbToProbIndex(double Prob);
double GetAccel();

EVENT_RESULT Evolver::Try_ChangeGeneSpeed()
	{
	vector<GeneInfo> Genes;
	vector<double> MACs;
	GetGenes(Genes);
	GetGeneWeightVec(Genes, MACs);

	if (Genes.empty())
		EV_FAILN(ChangeGeneSpeed, NoGenes)

	unsigned r = RandWeightDist(MACs);
	const GeneInfo &Gene = Genes[r];
	m_CurrentEventPos = Gene.Pos;

	double Accel = GetAccel();
	ChangeSpeed(Gene.Pos, Gene.Length, Accel);

	EV_ACCEPTN(ChangeGeneSpeed, Gene.Pos);
	}

void Evolver::ChangeSpeed(gpos_t Start, gpos_t Length, double Accel)
	{
	gpos_t Pos = Start;
	for (gpos_t i = 0; i < Length; ++i)
		{
		BaseInfo &Base = GetBase(Pos);
		if (Base.ProbIx == NEUTRAL_PROBIX)
			continue;
		double Prob = Base.GetAcceptProb();
		Prob = AccelProb(Prob, Accel);
		Base.ProbIx = ProbToProbIndex(Prob);
		if (Base.ProbIx == NEUTRAL_PROBIX)
			Base.ProbIx = MAX_NON_NEUTRAL_PROBIX;
		Pos = GetNextPos(Pos);
		}
	}
