#include "evolver.h"
#include "myrand.h"

double AccelProb(double p, double f);
uint8 ProbToProbIndex(double Prob);
double GetAccel();

EVENT_RESULT Evolver::Try_ChangeNGESpeed()
	{
	vector<gpos_t> Starts;
	vector<gpos_t> Lengths;
	vector<double> MACs;
	GetNGEs(Starts, Lengths, MACs);
	unsigned N = SIZE(Starts);
	asserta(SIZE(Lengths) == N);
	asserta(SIZE(MACs) == N);
	if (N == 0)
		EV_FAILN(ChangeNGESpeed, NoNGEs);

	unsigned r = RandWeightDist(MACs);
	gpos_t Length = Lengths[r];
	gpos_t Pos = Starts[r];
	m_CurrentEventPos = Pos;

	double Accel = GetAccel();
	ChangeSpeed(Pos, Length, Accel);

	EV_ACCEPTN(ChangeNGESpeed, Pos);
	}
