#include "utils.h"
#include "evolver.h"
#include "myrand.h"

EVENT_RESULT Evolver::Try_DeleteNXE()
	{
	vector<GeneInfo> Genes;
	vector<double> GeneMACs;
	InitTryGenes(Genes, GeneMACs);

	vector<gpos_t> Starts;
	vector<gpos_t> Lengths;
	vector<double> NXEMACs;
	unsigned Try = 1;

	GeneInfo Gene;
	for (; ; ++Try)
		{
#if	TRACE
		Log("\n");
		Log("Try %u\n", Try);
#endif
		if (Try >= 100)
			EV_FAILN(CreateNGE, MaxTries)

		bool Any = NextTryGene(Genes, GeneMACs, Gene);
		if (!Any)
			EV_FAILN(DeleteNXE, NoCandidates)

		GetNXEs(Gene.Pos, Gene.Length, Starts, Lengths, NXEMACs);

		unsigned N = SIZE(Starts);
		asserta(SIZE(Lengths) == N);
		asserta(SIZE(NXEMACs) == N);
		if (N > 0)
			break;
		}

	unsigned r = RandWeightDist(NXEMACs);

	gpos_t Pos = Starts[r];
	gpos_t Length = Lengths[r];
	m_CurrentEventPos = Pos;
	
	Deconstrain(Pos, Length, false);

	EV_ACCEPTN(DeleteNXE, Pos);
	}

void Evolver::Deconstrain(gpos_t Start, gpos_t Length, bool DisableGene)
	{
	gpos_t Pos = Start;
	for (gpos_t i = 0; i < Length; ++i)
		{
		BaseInfo &Base = GetBase(Pos);
		if (DisableGene)
			{
			if (Base.IsStartCodon())
				{
				map<gpos_t, unsigned>::iterator p = m_GeneIndexes.find(Pos);
				if (p != m_GeneIndexes.end())
					m_GeneIndexes.erase(p);
				}
			Base.Neutralize();
			}
		Base.Deconstrain();
		Pos = GetNextPos(Pos);
		}
	}
