#include "evolver.h"
#include "eventresult.h"
#include "getopts.h"
#include "evomodel.h"

#define E(e)	EVENT_RESULT Do_##e(Evolver &Ev)	\
	{												\
	return Ev.Try_##e();							\
	}
#include "events.h"

extern unsigned g_ValEvents;
extern unsigned g_StartValEvents;
extern unsigned g_FailEvent;

PTR_TRY_EVENT_FUNC TryEventFuncs[] =
	{
#define E(e)	Do_##e,
#include "events.h"
	};

EVENT_RESULT Evolver::TryEvent()
	{
	EVENT_RESULT Result = ER_Fail;
	for (unsigned Try = 0; Try < P_EventFailTries; ++Try)
		{
		if (m_LogEventFrom != UINT_MAX)
			SetLogEvents(m_EventIndex >= m_LogEventFrom && m_EventIndex <= m_LogEventTo);

		m_CurrentEvent = GetRandomEventType();
		asserta((unsigned) m_CurrentEvent < EventTypeCount);
		EVENT_RESULT Result = (TryEventFuncs[m_CurrentEvent])(*this);
		if (Result != ER_Fail)
			break;
		}
	m_CurrentEvent = EVENT_TYPE_Invalid;

	if (Result == ER_Accept)
		m_LastAcceptedEventIndex = m_EventIndex;

	if (m_EventIndex == g_FailEvent)
		Die("Fail at -failevent %u", g_FailEvent);

	bool Val = (g_StartValEvents > 0 || g_ValEvents > 0);
	if (Val && m_EventIndex >= g_StartValEvents && 
	  (g_ValEvents == 0 || (m_EventIndex - g_StartValEvents)%g_ValEvents == 0))
		{
		Validate(true);
		const char *FileName = ValueOpt("savegood");
		if (FileName != 0)
			ToFile(FileName);
		}

	return Result;
	}

EVENT_RESULT Evolver::Try_InterChrCopy()
	{
	Warning("Evolver::Try_InterChrCopy");
	return ER_Fail;
	}

EVENT_RESULT Evolver::Try_InterChrMove()
	{
	Warning("Evolver::Try_InterChrMove");
	return ER_Fail;
	}

EVENT_RESULT Evolver::Try_ChrFuse()
	{
	Warning("Evolver::Try_ChrFuse");
	return ER_Fail;
	}

EVENT_RESULT Evolver::Try_ChrSplit()
	{
	Warning("Evolver::Try_ChrSplit");
	return ER_Fail;
	}

EVENT_RESULT Evolver::Try_RecipTransloc()
	{
	Warning("Evolver::Try_RecipTransloc");
	return ER_Fail;
	}

EVENT_RESULT Evolver::Try_NonRecipTransloc()
	{
	Warning("Evolver::Try_NonRecipTransloc");
	return ER_Fail;
	}
