#include "evolver.h"
#include "ratemgr.h"

#define TRACE	0

EVENT_RESULT Evolver::Try_Invert()
	{
	gpos_t InvertPos = GetRandomPos();
	if (InvertPos == GPOS_T_MAX)
		EV_FAIL(Invert, 0, GetRandomPos)
	m_CurrentEventPos = InvertPos;

	EV_GETLENGTH(Invert, InvertLength)
	if (InvertLength == GPOS_T_MAX)
		EV_FAIL(Invert, InvertLength, GetLength)

	if (!RangeExists(InvertPos, InvertLength))
		EV_FAIL(Invert, InvertLength, RangeExists)

	ACCEPT_INVERT(Invert, InvertPos, InvertLength)

#if	TRACE
	Log("Invert %u L %u\n", InvertPos, InvertLength);
	gpos_t EndPos = GetRangeEndPos(InvertPos, InvertLength);
	Log("From pos neigh:\n");
	LogNeighborRegions(InvertPos);
	Log("To pos neigh:\n");
	LogNeighborRegions(EndPos);
	Log("All:\n");
	LogRegions(InvertPos, InvertLength);
#endif

	Invert(InvertPos, InvertLength);

#if	TRACE
	Log("AFTER\n", InvertPos, InvertLength);
	Log("From pos neigh:\n");
	LogNeighborRegions(InvertPos);
	Log("To pos neigh:\n");
	LogNeighborRegions(EndPos);
	Log("All:\n");
	LogRegions(InvertPos, InvertLength);
#endif

	EV_ACCEPT(Invert, InvertPos, InvertLength)
	}
