#include "evolver.h"
#include "ratemgr.h"
#include "myrand.h"

EVENT_RESULT Evolver::Try_MEInsert()
	{
	gpos_t InsertPos = GetRandomPos();
	if (InsertPos == GPOS_T_MAX)
		EV_FAIL(MEInsert, 0, GetRandomPos)

	m_CurrentEventPos = InsertPos;
	MEInfo &ME = GetRandomME();
	string Seq = ME.Seq;
	bool DoDel = RandTrue(ME.FractWithDeletion);
	if (DoDel)
		{
		unsigned DelPos = RandInt(SIZE(Seq));
		unsigned DelLength = (unsigned)
		  (RandNorm(ME.MeanDeleteLength, ME.StdDevDeleteLength) + 0.5);
		Seq = Seq.substr(DelPos, DelLength);
		++ME.DeleteCount;
		}

	bool DoInvert = RandTrue(0.5);
	if (DoInvert)
		{
		void RevComp(string &Seq);
		RevComp(Seq);
		}

	ACCEPT_INSERT(MEInsert, InsertPos, Seq)

	Insert(InsertPos, Seq);
	++ME.AcceptedInsertCount;
	ME.InsertedBaseCount += SIZE(Seq);

	gpos_t InsertLength = SIZE(Seq);
	EV_ACCEPT(MEInsert, InsertPos, InsertLength);
	}
