#include "evolver.h"
#include "revfile.h"
#include "getopts.h"
#include "progress.h"

extern int g_EvoMainResult;

void ValGenes()
	{
	const char *InSeqFileName = RequiredValueOpt("valgenes");
	const char *InAnnotFileName = RequiredValueOpt("annots");
	unsigned GenomeIndex = 0;
	IntOpt("genix", &GenomeIndex);
	unsigned ChrId = 0;
	IntOpt("chrid", &ChrId);
	const char *InChrName = ValueOpt("chrname");
	bool Dump = FlagOpt("dump");

	RevFile In;
	In.Open(InSeqFileName);

	if (InChrName != 0)
		ChrId = In.GetChrId(GenomeIndex, InChrName);
	else
		InChrName = In.GetChrName(GenomeIndex, ChrId).c_str();

	Evolver Evo;
	Evo.FromRevFile(In, GenomeIndex, ChrId, true);
	Evo.GetAnnots(InAnnotFileName, InChrName);
	unsigned ErrCount = Evo.ValidateGenes();
	Progress("%u errors found", ErrCount);
	if (Dump)
		{
		vector<GeneInfo> Genes;
		Evo.GetGenes(Genes);
		Evo.LogGenes(Genes);
		}

	In.Close();

	if (ErrCount > 0)
		g_EvoMainResult = 1;
	}
