#ifdef _MSC_VER
#include <windows.h>
#include <psapi.h>
#include <crtdbg.h>
#include <assert.h>
#include "getopts.h"
#include "utils.h"

double GetRAMSize()
	{
	MEMORYSTATUS MS;
	GlobalMemoryStatus(&MS);
	return (double) MS.dwTotalPhys;
	}

static double g_uPeakMemUseBytes;

double GetPeakMemUseBytes()
	{
	return g_uPeakMemUseBytes;
	}

double GetMemUseBytes()
	{
	HANDLE hProc = GetCurrentProcess();
	PROCESS_MEMORY_COUNTERS PMC;
	BOOL bOk = GetProcessMemoryInfo(hProc, &PMC, sizeof(PMC));
	if (!bOk)
		return 1000000;
	double uBytes = (double) PMC.WorkingSetSize;
	if (uBytes > g_uPeakMemUseBytes)
		g_uPeakMemUseBytes = uBytes;
	return uBytes;
	}

void OSInit()
	{
// Multi-tasking does not work well in CPU-bound
// console apps running under Win32.
// Reducing the process priority allows GUI apps
// to run responsively in parallel.
	SetPriorityClass(GetCurrentProcess(), BELOW_NORMAL_PRIORITY_CLASS);

	_CrtSetDbgFlag(0);
//	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);
//	_CrtSetBreakAlloc(53);
//	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF| _CRTDBG_CHECK_ALWAYS_DF);
	}

void ValidateHeap(const char *Msg)
	{
	if (!_CrtCheckMemory())
		Die("ValidateHeap(%s)", Msg);
	}

void ChkMem()
	{
	if (!_CrtCheckMemory())
		Die("ChkMem()");
	}

#endif
