#ifndef WORDHIST_H
#define WORDHIST_H

#include "types.h"
#include "xlat.h"
#include <stdio.h>

const unsigned WordHistMagic = 0x28158;

struct WordHistHdr
	{
	unsigned Magic;
	unsigned WordSize;
	uint64 GenomeSize;
	ALPHA Alpha;
	};

class WordHist
	{
public:
	WordHist();
	virtual ~WordHist();

public:
	void Init(ALPHA Alpha, unsigned WordSize);
	void IncWordCount(uint64 Word);
	void SetWordCount(uint64 Word, unsigned Count);
	unsigned GetCount(uint64 Word) const;
	uint64 GetTotalCount() const;
	void ToFile(const char *FileName, uint64 GenomeSize) const;
	void FromFile(const char *FileName);
	void Free();
	ALPHA GetAlpha() const { return m_Alpha; }
	unsigned GetWordSize() const { return m_WordSize; }
	uint64 GetGenomeSize() const { return m_GenomeSize; }

private:
	uint64 m_MaxCount;
	uint64 m_WordCount;
	uint64 m_GenomeSize;
	COUNT_TYPE *m_Counts;
	ALPHA m_Alpha;
	unsigned m_WordSize;
	};

#endif	// WORDHIST_H
