#include <stdio.h>

void Credits()
	{
	fprintf(stderr,
"\n"
"orrb v1.0 written by Robert C. Edgar\n"
"http://www.drive5.com/orrb\n"
"This software is donated to the public domain.\n"
"Algorithm developed by Matthew Hill and Arend Sidow.\n"
"\n");
	}

void AdvancedOptions()
	{
	fprintf(stderr,

"\n"
"\n"
"Create a word count histogram file given a sequence file:\n"
"\n"
"orrb -makehist <genome> -hist <hist_filename> -wordsize <w> [-append]\n"
"\n"
"   <hist_filename>     Word count ('histogram') data file.\n"
"   -append             Append counts to an existing file. If the file does not\n"
"                         exist, is created. Useful for (e.g.) a loop over\n"
"                         chromosome or scaffold files if the full genome\n"
"                         is very large.\n"
"   -aminoseq           Input sequence is in amino acid alphabet.\n"
"   -xlat               Store amino acid word counts, default is nucleotide.\n"
"\n"
"\n"
"Create a masking table file given two histogram files:\n"
"\n"
"orrb -maketab -in1 <hist_filename1> -in2 <hist_filename2> -tab <tab_filename> -wordsize <w> thresh_spec\n"
"\n"
"   <tab_filename>      Masking table file, specifies whether or not to mask each word.\n"
"\n"
"\n"
"Mask a sequence file given a masking table:\n"
"\n"
"orrb -mask <genome> -out <genome_masked> -tab <tab_filename> -wordsize <w> [-hardmask] [-overwrite]\n"
"\n"
"\n"
"Extract ORFs from a nucleotide sequence:\n"
"\n"
"orrb -xorfs <genome> -out <orf_filename> [-minframe <f>] [-nuc]\n"
"\n"
"    <orf_filename>     FASTA file containing ORFs.\n"
"    <f>                Minimum ORF length in nucleotides, default 99.\n"
"    -nuc               Write ORFs in DNA alphabet, default is amino acids.\n"
"\n"
"\n"
"Compute masking statistics given a genome file:\n"
"\n"
"orrb -maskstats <genome> -wordsize <w>\n"
"\n"
"\n"
"Compare two different masks on the same sequence:\n"
"\n"
"orrb -cmpmask -in1 <genome> -in2 <genome> -wordsize <w>\n"
"\n"
"\n"
);
	}

void Usage()
	{
	fprintf(stderr,
"\n"
"\n"
"Basic usage:\n"
"\n"
"orrb -mask <genome1> -target <genome2> -out <genome1_masked> -wordsize <w>\n"
"        <thresh_spec> [-hardmask] [-overwrite] [-pattern <p>]\n"
"        [-prot <orf_filename>] [-minframe <m>]\n"
"\n"
"   <genome1>             FASTA file of sequence to be masked.\n"
"   <genome2>             FASTA file of second sequence for word count statistics.\n"
"   <genome1_masked>      File name for masked version of genome1, FASTA format.\n"
"   <w>                   Word size.\n"
"   <thresh_spec>         Specifies the threshold for masking. There are three ways to do this:\n"
"      -threshold <t>         Mask if s = sqrt(count_genome1 * count_genome2) > t.\n"
"      -timesexpected <f>     Mask if s > f * (expected value of s given random genomes of same lengths).\n"
"      -pcttomask <p>         Set <t> so that approximately <p> percent of genome1 will be masked.\n"
"      -threshalpha <a>       Mask if 4^k*(X1/L1)^(z/2)*(X2/L2)^((2-z)/2) > a, a is floating-point.\n"
"   -overwrite            Ignore any existing soft masking, i.e. force to upper case,\n"
"                           unless threshold exceeded. Default is to keep existing soft masking.\n"
"   -hardmask             Mask using Ns. Default is to soft-mask, i.e. change to lower case.\n"
"   -pattern              Which letters to mask in a word, string of 1s and 0s, 1=mask, 0=don't mask.\n"
"                           Default is the middle letter.\n"
"                           Example: -pattern 01110 masks three middle letters in 5-mer.\n"
"   -prot <orf_filename>  Mask based on word counts in ORFs in genome1 (useful for translated blasts).\n"
"   -minframe <m>         Minimum ORF frame length in nucleotides, default 99.\n"
"\n"
"Optional arguments that can be used with any function:\n"
"\n"
"   -log <logfile>   Record warning, error and informational messages to logfile.\n"
"   -quiet           Do not display progress messages to stderr.\n"
"\n"
"\n"
"For brief help on advanced options:\n"
"\n"
"orrb -advanced_options\n"
"\n"
	);
	}
