#include "utils.h"
#include "xlat.h"
#include <ctype.h>

// A lot of duplication with gencode
// should really consolidate but
// not worth the trouble.

#define TRACE	0

bool IsACGT[256] =
	{
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0
	};

unsigned NucCode[256] =
	{
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 1, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 2, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0
	};

unsigned CompNucCode[256] =
	{
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 3, 0, 2, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 3, 0, 2, 0, 0, 0, 1, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0
	};

unsigned AminoCode[256];
bool InitAminoCode()
	{
	for (unsigned i = 0; i < 256; ++i)
		AminoCode[i] = 0xff;

	unsigned j = 0;
#define	AMINO(c)	AminoCode[tolower(c)] = j; AminoCode[(unsigned char) c] = j++;
	AMINO('A');
	AMINO('C');
	AMINO('D');
	AMINO('E');
	AMINO('F');
	AMINO('G');
	AMINO('H');
	AMINO('I');
	AMINO('K');
	AMINO('L');
	AMINO('M');
	AMINO('N');
	AMINO('P');
	AMINO('Q');
	AMINO('R');
	AMINO('S');
	AMINO('T');
	AMINO('V');
	AMINO('W');
	AMINO('Y');
#undef AMINO
	return true;
	}
static bool AminoCodeInitialized = InitAminoCode();

char NucCodeToChar[4] =
	{
	'A', 'C', 'G', 'T'
	};

/***
The genetic code:
	AAA Lys K
	AAC Asn N
	AAG Lys K
	AAT Asn N
	ACA Thr T
	ACC Thr T
	ACG Thr T
	ACT Thr T
	AGA Arg R
	AGC Ser S
	AGG Arg R
	AGT Ser S
	ATA Ile I
	ATC Ile I
	ATG Met M
	ATT Ile I
	CAA Gln Q
	CAC His H
	CAG Gln Q
	CAT His H
	CCA Pro P
	CCC Pro P
	CCG Pro P
	CCT Pro P
	CGA Arg R
	CGC Arg R
	CGG Arg R
	CGT Arg R
	CTA Leu L
	CTC Leu L
	CTG Leu L
	CTT Leu L
	GAA Glu E
	GAC Asp D
	GAG Glu E
	GAT Asp D
	GCA Ala A
	GCC Ala A
	GCG Ala A
	GCT Ala A
	GGA Gly G
	GGC Gly G
	GGG Gly G
	GGT Gly G
	GTA Val V
	GTC Val V
	GTG Val V
	GTT Val V
	TAA STP *
	TAC Tyr Y
	TAG STP *
	TAT Tyr Y
	TCA Ser S
	TCC Ser S
	TCG Ser S
	TCT Ser S
	TGA STP *
	TGC Cys C
	TGG Trp W
	TGT Cys C
	TTA Leu L
	TTC Phe F
	TTG Leu L
	TTT Phe F
***/

static const unsigned Mask = 0x3F;

enum AMINO_ACID
	{
	Ala,  // A
	Cys,  // C
	Asp,  // D
	Glu,  // E
	Phe,  // F
	Gly,  // G
	His,  // H
	Ile,  // I
	Lys,  // K
	Leu,  // L
	Asn,  // N
	Pro,  // P
	Gln,  // Q
	Arg,  // R
	Ser,  // S
	Thr,  // T
	Val,  // V
	Trp,  // W
	Tyr,  // Y
	Met,  // M
	STP   // *
	};

static char AminoAcidToChar(AMINO_ACID a)
	{
	switch (a)
		{
	case Ala: return 'A';
	case Cys: return 'C';
	case Asp: return 'D';
	case Glu: return 'E';
	case Phe: return 'F';
	case Gly: return 'G';
	case His: return 'H';
	case Ile: return 'I';
	case Lys: return 'K';
	case Leu: return 'L';
	case Met: return 'M';
	case Asn: return 'N';
	case Pro: return 'P';
	case Gln: return 'Q';
	case Arg: return 'R';
	case Ser: return 'S';
	case Thr: return 'T';
	case Val: return 'V';
	case Trp: return 'W';
	case Tyr: return 'Y';
	case STP: return '*';
		}
	return '?';
	}

static AMINO_ACID ThreemerToAminoAcid(unsigned Threemer)
	{
	assert((Threemer & ~Mask) == 0);

#define A	0
#define	C	1
#define G	2
#define T	3
#define CODE(c1, c2, c3)	((c3) | ((c2) << 2) | ((c1) << 4))

	switch (Threemer)
		{
	case CODE(T, T, T): return Phe;
	case CODE(T, T, C): return Phe;
	case CODE(T, T, A): return Leu;
	case CODE(T, T, G): return Leu;
	case CODE(C, T, T): return Leu;
	case CODE(C, T, C): return Leu;
	case CODE(C, T, A): return Leu;
	case CODE(C, T, G): return Leu;
	case CODE(A, T, T): return Ile;
	case CODE(A, T, C): return Ile;
	case CODE(A, T, A): return Ile;
	case CODE(A, T, G): return Met;
	case CODE(G, T, T): return Val;
	case CODE(G, T, C): return Val;
	case CODE(G, T, A): return Val;
	case CODE(G, T, G): return Val;
	case CODE(T, C, T): return Ser;
	case CODE(T, C, C): return Ser;
	case CODE(T, C, A): return Ser;
	case CODE(T, C, G): return Ser;
	case CODE(C, C, T): return Pro;
	case CODE(C, C, C): return Pro;
	case CODE(C, C, A): return Pro;
	case CODE(C, C, G): return Pro;
	case CODE(A, C, T): return Thr;
	case CODE(A, C, C): return Thr;
	case CODE(A, C, A): return Thr;
	case CODE(A, C, G): return Thr;
	case CODE(G, C, T): return Ala;
	case CODE(G, C, C): return Ala;
	case CODE(G, C, A): return Ala;
	case CODE(G, C, G): return Ala;
	case CODE(T, A, T): return Tyr;
	case CODE(T, A, C): return Tyr;
	case CODE(T, A, A): return STP;
	case CODE(T, A, G): return STP;
	case CODE(C, A, T): return His;
	case CODE(C, A, C): return His;
	case CODE(C, A, A): return Gln;
	case CODE(C, A, G): return Gln;
	case CODE(A, A, T): return Asn;
	case CODE(A, A, C): return Asn;
	case CODE(A, A, A): return Lys;
	case CODE(A, A, G): return Lys;
	case CODE(G, A, T): return Asp;
	case CODE(G, A, C): return Asp;
	case CODE(G, A, A): return Glu;
	case CODE(G, A, G): return Glu;
	case CODE(T, G, T): return Cys;
	case CODE(T, G, C): return Cys;
	case CODE(T, G, A): return STP;
	case CODE(T, G, G): return Trp;
	case CODE(C, G, T): return Arg;
	case CODE(C, G, C): return Arg;
	case CODE(C, G, A): return Arg;
	case CODE(C, G, G): return Arg;
	case CODE(A, G, T): return Ser;
	case CODE(A, G, C): return Ser;
	case CODE(A, G, A): return Arg;
	case CODE(A, G, G): return Arg;
	case CODE(G, G, T): return Gly;
	case CODE(G, G, C): return Gly;
	case CODE(G, G, A): return Gly;
	case CODE(G, G, G): return Gly;
		}
#undef CODE
#undef A
#undef C
#undef G
#undef T
	Die("Invalid code");
	return STP;
	}

char CharsToAmino(char Char1, char Char2, char Char3)
	{
	if (toupper(Char1) == 'N' || toupper(Char2) == 'N' || toupper(Char3) == 'N')
		return 'X';

#define A	0
#define	C	1
#define G	2
#define T	3
#define CASE(c1, c2, c3, a)	case ((c3 << 4) | (c2 << 2) | c1): return AminoAcidToChar(a)
	unsigned v1 = NucCode[(unsigned char) Char1];
	unsigned v2 = NucCode[(unsigned char) Char2];
	unsigned v3 = NucCode[(unsigned char) Char3];
	unsigned v = ((v3 << 4) | (v2 << 2) | v1);
	switch (v)
		{
	CASE(T, T, T, Phe);
	CASE(T, T, C, Phe);
	CASE(T, T, A, Leu);
	CASE(T, T, G, Leu);
	CASE(C, T, T, Leu);
	CASE(C, T, C, Leu);
	CASE(C, T, A, Leu);
	CASE(C, T, G, Leu);
	CASE(A, T, T, Ile);
	CASE(A, T, C, Ile);
	CASE(A, T, A, Ile);
	CASE(A, T, G, Met);
	CASE(G, T, T, Val);
	CASE(G, T, C, Val);
	CASE(G, T, A, Val);
	CASE(G, T, G, Val);
	CASE(T, C, T, Ser);
	CASE(T, C, C, Ser);
	CASE(T, C, A, Ser);
	CASE(T, C, G, Ser);
	CASE(C, C, T, Pro);
	CASE(C, C, C, Pro);
	CASE(C, C, A, Pro);
	CASE(C, C, G, Pro);
	CASE(A, C, T, Thr);
	CASE(A, C, C, Thr);
	CASE(A, C, A, Thr);
	CASE(A, C, G, Thr);
	CASE(G, C, T, Ala);
	CASE(G, C, C, Ala);
	CASE(G, C, A, Ala);
	CASE(G, C, G, Ala);
	CASE(T, A, T, Tyr);
	CASE(T, A, C, Tyr);
	CASE(T, A, A, STP);
	CASE(T, A, G, STP);
	CASE(C, A, T, His);
	CASE(C, A, C, His);
	CASE(C, A, A, Gln);
	CASE(C, A, G, Gln);
	CASE(A, A, T, Asn);
	CASE(A, A, C, Asn);
	CASE(A, A, A, Lys);
	CASE(A, A, G, Lys);
	CASE(G, A, T, Asp);
	CASE(G, A, C, Asp);
	CASE(G, A, A, Glu);
	CASE(G, A, G, Glu);
	CASE(T, G, T, Cys);
	CASE(T, G, C, Cys);
	CASE(T, G, A, STP);
	CASE(T, G, G, Trp);
	CASE(C, G, T, Arg);
	CASE(C, G, C, Arg);
	CASE(C, G, A, Arg);
	CASE(C, G, G, Arg);
	CASE(A, G, T, Ser);
	CASE(A, G, C, Ser);
	CASE(A, G, A, Arg);
	CASE(A, G, G, Arg);
	CASE(G, G, T, Gly);
	CASE(G, G, C, Gly);
	CASE(G, G, A, Gly);
	CASE(G, G, G, Gly);
		}
#undef CASE
#undef A
#undef C
#undef G
#undef T
	Die("Invalid code");
	return '?';
	}

#if	0
static char *AminoAcidToStr(AMINO_ACID a)
	{
	switch (a)
		{
	case Ala: return "Ala";
	case Cys: return "Cys";
	case Asp: return "Asp";
	case Glu: return "Glu";
	case Phe: return "Phe";
	case Gly: return "Gly";
	case His: return "His";
	case Ile: return "Ile";
	case Lys: return "Lys";
	case Leu: return "Leu";
	case Met: return "Met";
	case Asn: return "Asn";
	case Pro: return "Pro";
	case Gln: return "Gln";
	case Arg: return "Arg";
	case Ser: return "Ser";
	case Thr: return "Thr";
	case Val: return "Val";
	case Trp: return "Trp";
	case Tyr: return "Tyr";
	case STP: return "STP";
		}
	return "???";
	}
#endif
static unsigned char AminoCharToVal[256];
static char AminoValToChar[256];

static bool AminoTableInit()
	{
	for (unsigned i = 0; i < 256; ++i)
		{
		AminoCharToVal[i] = 0xff;
		AminoValToChar[i] = '?';
		}

	unsigned Val = 0;
#define AMINO(c)										\
	AminoValToChar[Val] = c;							\
	AminoCharToVal[(unsigned char) c] = Val;			\
	AminoCharToVal[(unsigned char) tolower(c)] = Val++;

	AMINO('A');
	AMINO('C');
	AMINO('D');
	AMINO('E');
	AMINO('F');
	AMINO('G');
	AMINO('H');
	AMINO('I');
	AMINO('K');
	AMINO('L');
	AMINO('M');
	AMINO('N');
	AMINO('P');
	AMINO('Q');
	AMINO('R');
	AMINO('S');
	AMINO('T');
	AMINO('V');
	AMINO('W');
	AMINO('Y');

#undef AMINO
	assert(Val == 20);
	return true;
	}
static bool AminoTablesInitialized = AminoTableInit();

bool isacgt(char c)
	{
	return IsACGT[(unsigned char) c];
	}

bool isamino(char c)
	{
	return AminoCharToVal[(unsigned char) c] < 20;
	}

uint64 StrToXlatWord(const char *Str, unsigned WordSize)
	{
	uint64 f = 1;
	uint64 Value = 0;
	for (unsigned i = 0; i < WordSize; ++i)
		{
		char c = Str[i];
		if (!isamino(c))
			Die("StrToXlatWord: !isamino(0x02x)", c);
		unsigned Val = AminoCharToVal[(unsigned char) c];
		Value += Val*f;
		f *= 20;
		}
	return Value;
	}

uint64 CalcWordCount(ALPHA Alpha, unsigned WordSize)
	{
	switch (Alpha)
		{
	case ALPHA_Nucleo:
		return pow4(WordSize);
	case ALPHA_Amino:
		return pow20(WordSize);
	default:
		Die("CalcWordCount: invalid alpha=%d", Alpha);
		}
	return 0;
	}

const char *AminoWordToStr(uint64 Word, unsigned CodonCount)
	{
	static char Str[64];
	assert(CodonCount < 64);

	unsigned f = 1;
	for (unsigned i = 0; i < CodonCount; ++i)
		{
		unsigned a = (unsigned) ((Word/f)%20);
		Str[CodonCount - 1 - i] = AminoValToChar[a];
		f *= 20;
		}

	Str[CodonCount] = 0;
	return Str;
	}

bool NucWordToAminoWord(uint64 NucWord, unsigned CodonCount, uint64 *ptrAminoWord)
	{
#if	TRACE
	Log("%s ", NucWordToStr(NucWord, 3*CodonCount));
#endif

	uint64 AminoWord = 0;
	for (unsigned i = 0; i < CodonCount; ++i)
		{
		unsigned Threemer = (unsigned) ((NucWord >> (6*(CodonCount - 1 - i))) & Mask);
		AMINO_ACID a = ThreemerToAminoAcid(Threemer);
#if	TRACE
		Log(" %s=%c", NucWordToStr(Threemer, 3), AminoAcidToChar(a));
#endif
		if (a == STP)
			{
#if	TRACE
			Log("\n");
#endif
			return false;
			}
		AminoWord *= 20;
		AminoWord += a;
		}

#if	TRACE
	Log(" %s\n", XlatWordToStr(AminoWord, CodonCount));
#endif

	*ptrAminoWord = AminoWord;
	return true;
	}

uint64 NucStrToRCWord(const char *Str, unsigned WordSize)
	{
	unsigned RevWord = 0;
	for (unsigned i = 0; i < WordSize; ++i)
		{
		RevWord <<= 2;
		RevWord += CompNucCode[(unsigned char) Str[WordSize - i - 1]];
		}
	return RevWord;
	}

const char *NucWordToStr(uint64 Word, unsigned WordSize, char *Str)
	{
	for (unsigned i = 0; i < WordSize; ++i)
		{
		unsigned j = WordSize - i - 1;
		uint64 shifted = (Word >> (2*j));
		uint64 Bits = (shifted & 0x3);
		Str[i] = NucCodeToChar[Bits];
		}
	Str[WordSize] = 0;
	return Str;
	}

const char *NucWordToStr(uint64 Word, unsigned WordSize)
	{
	static char s[64];
	return NucWordToStr(Word, WordSize, s);
	}

uint64 RevCompNucWord(uint64 Word, unsigned WordLength)
	{
	// A=0 T=3
	// C=1 G=2
	// G=2 C=1
	// T=3 A=0
	static unsigned RevVal[4] =
		{
		3, 2, 1, 0
		};

	uint64 RevWord = 0;
	int Shift = 2*(WordLength - 1);
	for (unsigned i = 0; i < WordLength; ++i)
		{
		unsigned Val = ((unsigned) Word & 0x3);
		Word >>= 2;

		RevWord <<= 2;
		RevWord |= RevVal[Val];

		Shift -= 2;
		}

	return RevWord;
	}

uint64 NucStrToWord(const char *Str, unsigned WordSize)
	{
	uint64 Word = 0;
	for (unsigned i = 0; i < WordSize; ++i)
		{
		Word <<= 2;
		Word += NucCode[(unsigned char) Str[i]];
		}
	return Word;
	}

uint64 AminoStrToWord(const char *Str, unsigned CodonCount)
	{
	uint64 Word = 0;
	for (unsigned i = 0; i < CodonCount; ++i)
		{
		Word *= 20;
		Word += AminoCode[(unsigned char) Str[i]];
		}
	return Word;
	}

const char *AlphaToStr(ALPHA a)
	{
	switch (a)
		{
	case ALPHA_Nucleo:
		return "Nucleo";
	case ALPHA_Amino:
		return "Amino";
	default:
		;
		}
	return "???";
	}

char *CharTypeToStr(CHAR_TYPE t)
	{
	switch (t)
		{
	case CHAR_TYPE_HardMasked:
		return "HardMasked";
	case CHAR_TYPE_Upper:
		return "Upper";
	case CHAR_TYPE_SoftMasked:
		return "SoftMasked";
	case CHAR_TYPE_Other:
		return "Other";
		}
	Die("Invalid char type %d", t);
	return "???";
	}

CHAR_TYPE CharType(unsigned char c, ALPHA Alpha)
	{
	if (Alpha == ALPHA_Nucleo)
		{
		if (c == 'N' || c == 'n')
			return CHAR_TYPE_HardMasked;
		if (isupper(c) && isacgt(c))
			return CHAR_TYPE_Upper;
		if (islower(c) && isacgt(c))
			return CHAR_TYPE_SoftMasked;
		return CHAR_TYPE_Other;
		}
	else if (Alpha == ALPHA_Amino)
		{
		if (c == 'X' || c == 'x')
			return CHAR_TYPE_HardMasked;
		if (isamino(c))
			{
			if (isupper(c))
				return CHAR_TYPE_Upper;
			else
				return CHAR_TYPE_SoftMasked;
			}
		return CHAR_TYPE_Other;
		}
	else
		Die("Alpha %d not supported", Alpha);
	return CHAR_TYPE_Other;
	}
