#ifndef XLAT_H
#define XLAT_H

#include "types.h"

enum ALPHA
	{
	ALPHA_Invalid = 0,
	ALPHA_Nucleo = 1,
	ALPHA_Amino = 2
	};

enum CHAR_TYPE
	{
	CHAR_TYPE_Upper,
	CHAR_TYPE_SoftMasked,
	CHAR_TYPE_HardMasked,
	CHAR_TYPE_Other,
	CHAR_TYPE_Max = CHAR_TYPE_Other
	};

CHAR_TYPE CharType(unsigned char c, ALPHA Alpha);
char *CharTypeToStr(CHAR_TYPE t);

uint64 CalcWordCount(ALPHA Alpha, unsigned WordSize);

const char *NucWordToStr(uint64 Word, unsigned WordSize, char *Str);
const char *NucWordToStr(uint64 Word, unsigned WordSize);
const char *AminoWordToStr(uint64 Word, unsigned WordSize);
uint64 AminoStrToWord(const char *Str, unsigned WordSize);
uint64 NucStrToWord(const char *Str, unsigned WordSize);
uint64 NucStrToRCWord(const char *Str, unsigned WordSize);
uint64 RevCompNucWord(uint64 Word, unsigned WordLength);
bool NucWordToAminoWord(uint64 NucWord, unsigned WordSize, uint64 *ptrAminoWord);
const char *AlphaToStr(ALPHA Alpha);

extern bool IsACGT[256];
extern unsigned NucCode[256];
extern unsigned AminoCode[256];
extern unsigned CompNucCode[256];
extern char NucCodeToChar[4];

bool isamino(char c);
bool isacgt(char c);

#endif // XLAT_H
